题目描述(困难难度)

218. The Skyline Problem - 图1

给定几个矩形,矩形以坐标形式表示,[x1, x2, h],分别代表矩形与 x 轴左右交点的 x 坐标以及矩形的高度。

输出所有矩形组成的轮廓,只输出所有关键点即可。关键点用坐标 [x,y] 的形式。

思路分析?

自己也没有想出来解法,主要参考了下边的几个链接。

https://www.youtube.com/watch?v=GSBLe8cKu0s

https://www.geeksforgeeks.org/the-skyline-problem-using-divide-and-conquer-algorithm/

https://leetcode.com/problems/the-skyline-problem/discuss/61281/Java-divide-and-conquer-solution-beats-96

虽然明白了上边作者的解法,但并没有像以往一样理出作者是怎么想出解法的,或者说推导有点儿太马后炮了,并不能说服自己,所以下边介绍的解法只讲方法,没有一步一步的递进的过程了。

首先讲一下为什么题目要求我们输出那些关键点,换句话说,知道那些关键点我们怎么画出轮廓。

我们只需要从原点向右出发,沿着水平方向一直画线。

如果在正上方或者正下方遇到关键点,就拐向关键点。

到达关键点后继续向右水平画线,重复上边的过程即可。

可以结合下边的图看一下。

218. The Skyline Problem - 图2

解法一

有些类似归并排序的思想,divide and conquer 。

首先考虑,如果只给一个建筑 [x, y, h],那么答案是多少?

很明显输出的解将会是 [[x, h], [y, 0]],也就是左上角和右下角坐标。

接下来考虑,如果有建筑 A B C D E,我们知道了建筑 A B C 输出的解和 D E 输出的解,那么怎么把这两组解合并,得到 A B C D E 输出的解。

合并方法采用归并排序中双指针的方法,将两个指针分别指向两组解的开头,然后进行比对。具体的,看下边的例子。

每次选取 x 坐标较小的点,然后再根据一定规则算出高度,具体的看下边的过程。

  1. Skyline1 = {(1, 11), (3, 13), (9, 0), (12, 7), (16, 0)}
  2. Skyline2 = {(14, 3), (19, 18), (22, 3), (23, 13), (29, 0)}
  3. Skyline1 存储第一组的解。
  4. Skyline2 存储第二组的解。
  5. Result 存储合并后的解, Result = {}
  6. h1 表示将 Skyline1 中的某个关键点加入 Result 中时, 当前关键点的高度
  7. h2 表示将 Skyline2 中的某个关键点加入 Result 中时, 当前关键点的高度
  8. h1 = 0, h2 = 0
  9. i = 0, j = 0
  10. (1, 11), (3, 13), (9, 0), (12, 7), (16, 0)
  11. ^
  12. i
  13. (14, 3), (19, 18), (22, 3), (23, 13), (29, 0)
  14. ^
  15. j
  16. 比较 (1, 11) (14, 3)
  17. 比较 x 坐标, 1 < 14, 所以考虑 (1, 11)
  18. x 1, 接下来更新 height
  19. h1 = 11, height = max(h1, h2) = max(11, 0) = 11
  20. (1, 11) 加入到 Result
  21. Result = {(1, 11)}
  22. i 后移, i = i + 1 = 2
  23. (1, 11), (3, 13), (9, 0), (12, 7), (16, 0)
  24. ^
  25. i
  26. (14, 3), (19, 18), (22, 3), (23, 13), (29, 0)
  27. ^
  28. j
  29. 比较 (3, 13) (14, 3)
  30. 比较 x 坐标, 3 < 14, 所以考虑 (3, 13)
  31. x 3, 接下来更新 height
  32. h1 = 13, height = max(h1, h2) = max(13, 0) = 13
  33. (3, 13) 加入到 Result
  34. Result = {(1, 11), (3, 13)}
  35. i 后移, i = i + 1 = 3
  36. (9, 0) (12, 7) 同理
  37. 此时 h1 = 7
  38. Result {(1, 11), (3, 13), (9, 0), (12, 7)}
  39. i = 4
  40. (1, 11), (3, 13), (9, 0), (12, 7), (16, 0)
  41. ^
  42. i
  43. (14, 3), (19, 18), (22, 3), (23, 13), (29, 0)
  44. ^
  45. j
  46. 比较 (16, 0) (14, 3)
  47. 比较 x 坐标, 14 < 16, 所以考虑 (14, 3)
  48. x 14, 接下来更新 height
  49. h2 = 3, height = max(h1, h2) = max(7, 3) = 7
  50. (14, 7) 加入到 Result
  51. Result = {(1, 11), (3, 13), (9, 0), (12, 7), (14, 7)}
  52. j 后移, j = j + 1 = 2
  53. (1, 11), (3, 13), (9, 0), (12, 7), (16, 0)
  54. ^
  55. i
  56. (14, 3), (19, 18), (22, 3), (23, 13), (29, 0)
  57. ^
  58. j
  59. 比较 (16, 0) (19, 18)
  60. 比较 x 坐标, 16 < 19, 所以考虑 (16, 0)
  61. x 16, 接下来更新 height
  62. h1 = 0, height = max(h1, h2) = max(0, 3) = 3
  63. (16, 3) 加入到 Result
  64. Result = {(1, 11), (3, 13), (9, 0), (12, 7), (14, 7), (16, 3)}
  65. i 后移, i = i + 1 = 5
  66. 因为 Skyline1 没有更多的解了,所以只需要将 Skyline2 剩下的解按照上边 height 的更新方式继续加入到 Result 中即可
  67. Result = {(1, 11), (3, 13), (9, 0), (12, 7), (14, 7), (16, 3),
  68. (19, 18), (22, 3), (23, 13), (29, 0)}
  69. 我们会发现上边多了一些解, (14, 7) 并不是我们需要的, 因为之前已经有了 (12, 7), 所以我们需要将其去掉。
  70. Result = {(1, 11), (3, 13), (9, 0), (12, 7), (16, 3), (19, 18),
  71. (22, 3), (23, 13), (29, 0)}

代码的话,模仿归并排序,我们每次将 buildings 对半分,然后进入递归,将得到的两组解按照上边的方式合并即可。

  1. public List<List<Integer>> getSkyline(int[][] buildings) {
  2. if(buildings.length == 0){
  3. return new ArrayList<>();
  4. }
  5. return merge(buildings, 0, buildings.length - 1);
  6. }
  7. private List<List<Integer>> merge(int[][] buildings, int start, int end) {
  8. List<List<Integer>> res = new ArrayList<>();
  9. //只有一个建筑, 将 [x, h], [y, 0] 加入结果
  10. if (start == end) {
  11. List<Integer> temp = new ArrayList<>();
  12. temp.add(buildings[start][0]);
  13. temp.add(buildings[start][2]);
  14. res.add(temp);
  15. temp = new ArrayList<>();
  16. temp.add(buildings[start][1]);
  17. temp.add(00);
  18. res.add(temp);
  19. return res;
  20. }
  21. int mid = (start + end) >>> 1;
  22. //第一组解
  23. List<List<Integer>> Skyline1 = merge(buildings, start, mid);
  24. //第二组解
  25. List<List<Integer>> Skyline2 = merge(buildings, mid + 1, end);
  26. //下边将两组解合并
  27. int h1 = 0;
  28. int h2 = 0;
  29. int i = 0;
  30. int j = 0;
  31. while (i < Skyline1 .size() || j < Skyline2 .size()) {
  32. long x1 = i < Skyline1 .size() ? Skyline1 .get(i).get(0) : Long.MAX_VALUE;
  33. long x2 = j < Skyline2 .size() ? Skyline2 .get(j).get(0) : Long.MAX_VALUE;
  34. long x = 0;
  35. //比较两个坐标
  36. if (x1 < x2) {
  37. h1 = Skyline1 .get(i).get(1);
  38. x = x1;
  39. i++;
  40. } else if (x1 > x2) {
  41. h2 = Skyline2 .get(j).get(1);
  42. x = x2;
  43. j++;
  44. } else {
  45. h1 = Skyline1 .get(i).get(1);
  46. h2 = Skyline2 .get(j).get(1);
  47. x = x1;
  48. i++;
  49. j++;
  50. }
  51. //更新 height
  52. int height = Math.max(h1, h2);
  53. //重复的解不要加入
  54. if (res.isEmpty() || height != res.get(res.size() - 1).get(1)) {
  55. List<Integer> temp = new ArrayList<>();
  56. temp.add((int) x);
  57. temp.add(height);
  58. res.add(temp);
  59. }
  60. }
  61. return res;
  62. }

上边有两个技巧需要注意,技巧只是为了让算法更简洁一些,不用也是可以的,但可能会麻烦些。

一个就是下边的部分

  1. long x1 = i < Skyline1 .size() ? Skyline1 .get(i).get(0) : Long.MAX_VALUE;
  2. long x2 = j < Skyline2 .size() ? Skyline2 .get(j).get(0) : Long.MAX_VALUE;

Skyline1 或者 Skyline2 遍历完的时候,我们给他赋值为一个很大的数,这样的话我们可以在一个 while 循环中完成我们的算法,不用再单独考虑当一个遍历完的处理。

这里需要注意的是,我们将 x1x2 定义为 long,算是一个 trick,可以保证我们给 x1 或者 x2 赋的 Long.MAX_VALUE 这个值,后续不会出现 x1 == x2。因为原始数据都是 int 范围的。

当然也可以有其他的处理方式,比如当遍历完的时候,给 x1 或者 x2 赋值成负数,不过这样的话就需要更改后续的 if 判断条件,不细说了。

另外一个技巧就是下边的部分。

  1. if (res.isEmpty() || height != res.get(res.size() - 1).get(1)) {

我们在将当前结果加入的 res 中时,判断一下当前的高度是不是 res 中最后一个的高度,可以提前防止加入重复的点。

解法二

直接讲解法,比较好理解。

218. The Skyline Problem - 图3

只考虑每个 building 的左上角和右上角坐标,将所有点按 x 坐标排序,然后开始遍历。

需要一个优先队列来存储遍历坐标的高度,也就是 y 轴坐标。

对于左上角坐标和右上角坐标有不同的处理方式。

遇到左上角坐标,将其 y 坐标加入到优先队列中。

遇到右上角坐标,将其 y 坐标从优先队列中删除,也就是删除了其对应的左上角坐标的 y 值。

最后判断优先队列中的最高高度相对于之前是否更新,如果更新了的话,就将当前的 x 以及更新后的最高高度作为一个坐标加入到最终结果中。

  1. buildings [2 9 10], [3 7 15], [5 12 12], [15 20 10], [19 24 8]
  2. 根据 buildings 求出每个 building 的左上角和右上角坐标
  3. 将所有坐标按照 x 排序, 并标记当前坐标是左上角坐标还是右上角坐标
  4. l(2,10) l(3,15) l(5,12) r(7,15) r(9,10) r(12,12)
  5. l(15,10) l(19,8) r(20,10) r(24,8)
  6. PriorityQueue = {0}, preMax = 0
  7. l(2,10) 10 加入优先队列
  8. preMax = 0, PriorityQueue = {0 10}
  9. 当前 PriorityQueue max = 10, 相对于 preMax 更新了
  10. (2,10) 加入到 res, res = {(2,10)}
  11. 更新 preMax = 10
  12. l(3,15) 15 加入优先队列
  13. preMax = 10, PriorityQueue = {0 10 15}
  14. 当前 PriorityQueue max = 15, 相对于 preMax 更新了
  15. (3,15) 加入到 res, res = {(2,10) (3,15)}
  16. 更新 preMax = 15
  17. l(5,12) 12 加入优先队列
  18. preMax = 15, PriorityQueue = {0 10 15 12}
  19. 当前 PriorityQueue max = 15, 相对于 preMax 没有更新
  20. res 不变
  21. r(7,15) , 遇到右上角坐标, 15 从优先队列删除
  22. preMax = 15, PriorityQueue = {0 10 12}
  23. 当前 PriorityQueue max = 12, 相对于 preMax 更新了
  24. (7,max) (7,12) 加入到 res, res = {(2,10) (3,15) (7,12)}
  25. 更新 preMax = 12
  26. r(9,10) , 遇到右上角坐标, 10 从优先队列删除
  27. preMax = 12, PriorityQueue = {0 12}
  28. 当前 PriorityQueue max = 12, 相对于 preMax 没有更新
  29. res 不变
  30. r(12,12) , 遇到右上角坐标, 12 从优先队列删除
  31. preMax = 12, PriorityQueue = {0}
  32. 当前 PriorityQueue max = 0, 相对于 preMax 更新了
  33. (12,max) (7,0) 加入到 res, res = {(2,10) (3,15) (7,12) (12,0)}
  34. 更新 preMax = 0
  35. 后边的同理,就不进行下去了。

然后再考虑一些边界情况,开始给坐标排序的时候我们是根据 x 坐标大小,当 x 坐标相等的时候怎么办呢?

考虑两个坐标比较的时候,x 坐标相等会有三种情况。

  1. 当两个坐标都是左上角坐标,我们要将高度高的排在前边
  2. 当两个坐标都是右上角坐标,我们要将高度低的排在前边
  3. 当两个坐标一个是左上角坐标,一个是右上角坐标,我们需要将左上角坐标排在前边

上边的三条规则也是根据三种情况归纳总结出来的,大家可以举例子来判断。

有了这三个规则,然后写代码的话就会很繁琐,这里有个技巧。存左上角坐标的时候, 将高度(y)存为负数。存右上角坐标的时候,将高度(y)存为正数。

这么做有两个作用。

一个作用就是可以根据高度的正负数区分当前是左上角坐标还是右上角坐标。

另一个作用就是可以通过一个比较器,就实现上边的三条比较规则。

  1. public int compare(List<Integer> p1, List<Integer> p2) {
  2. int x1 = p1.get(0);
  3. int y1 = p1.get(1);
  4. int x2 = p2.get(0);
  5. int y2 = p2.get(1);
  6. //不相等时候,按照 x 从小到大排序
  7. if (x1 != x2) {
  8. return x1 - x2;
  9. //相等时候,只需要将高度相减就满足了上边的三条规则,可以尝试验证一下
  10. } else {
  11. return y1 - y2;
  12. }
  13. }

另一个技巧在举例子的时候已经用到了,就是优先队列初始的时候将 0 加入。

然后其他部分代码的话按照上边举的例子写就可以了。

  1. public List<List<Integer>> getSkyline(int[][] buildings) {
  2. List<List<Integer>> points = new ArrayList<>();
  3. List<List<Integer>> results = new ArrayList<>();
  4. int n = buildings.length;
  5. //求出左上角和右上角坐标, 左上角坐标的 y 存负数
  6. for (int[] b : buildings) {
  7. List<Integer> p1 = new ArrayList<>();
  8. p1.add(b[0]);
  9. p1.add(-b[2]);
  10. points.add(p1);
  11. List<Integer> p2 = new ArrayList<>();
  12. p2.add(b[1]);
  13. p2.add(b[2]);
  14. points.add(p2);
  15. }
  16. //将所有坐标排序
  17. Collections.sort(points, new Comparator<List<Integer>>() {
  18. @Override
  19. public int compare(List<Integer> p1, List<Integer> p2) {
  20. int x1 = p1.get(0);
  21. int y1 = p1.get(1);
  22. int x2 = p2.get(0);
  23. int y2 = p2.get(1);
  24. if (x1 != x2) {
  25. return x1 - x2;
  26. } else {
  27. return y1 - y2;
  28. }
  29. }
  30. });
  31. //默认的优先队列是最小堆,我们需要最大堆,每次需要得到队列中最大的元素
  32. Queue<Integer> queue = new PriorityQueue<>(new Comparator<Integer>() {
  33. @Override
  34. public int compare(Integer i1, Integer i2) {
  35. return i2 - i1;
  36. }
  37. });
  38. queue.offer(0);
  39. int preMax = 0;
  40. for (List<Integer> p : points) {
  41. int x = p.get(0);
  42. int y = p.get(1);
  43. //左上角坐标
  44. if (y < 0) {
  45. queue.offer(-y);
  46. //右上角坐标
  47. } else {
  48. queue.remove(y);
  49. }
  50. int curMax = queue.peek();
  51. //最大值更新了, 将当前结果加入
  52. if (curMax != preMax) {
  53. List<Integer> temp = new ArrayList<>();
  54. temp.add(x);
  55. temp.add(curMax);
  56. results.add(temp);
  57. preMax = curMax;
  58. }
  59. }
  60. return results;
  61. }

代码的话还能优化一下,上边代码中最常出现的三种操作。

添加高度,时间复杂度 O(log(n))

删除高度,时间复杂度 O(n)

查看最大高度,时间复杂度 O(1)

有一个操作是 O(n),加上外层的遍历,所以会使得最终的时间复杂度成为 O(n²)

之所以是上边的时间复杂度,因为我们使用的是优先队列。我们还可以使用 TreeMap,这样上边的三种操作时间复杂度就都是 O(log(n)) 了,最终的时间复杂度就变为 O(nlog(n))

TreeMap 的话 key 当然就是存高度了,因为可能添加重复的高度,所有value 的话存高度出现的次数即可。

代码的话,整体思想不需要改变,只需要改变添加高度、删除高度、查看最大高度的部分。

  1. public List<List<Integer>> getSkyline(int[][] buildings) {
  2. List<List<Integer>> points = new ArrayList<>();
  3. List<List<Integer>> results = new ArrayList<>();
  4. int n = buildings.length;
  5. //求出将左上角和右上角坐标, 左上角坐标的 y 存负数
  6. for (int[] b : buildings) {
  7. List<Integer> p1 = new ArrayList<>();
  8. p1.add(b[0]);
  9. p1.add(-b[2]);
  10. points.add(p1);
  11. List<Integer> p2 = new ArrayList<>();
  12. p2.add(b[1]);
  13. p2.add(b[2]);
  14. points.add(p2);
  15. }
  16. //将所有坐标排序
  17. Collections.sort(points, new Comparator<List<Integer>>() {
  18. @Override
  19. public int compare(List<Integer> p1, List<Integer> p2) {
  20. int x1 = p1.get(0);
  21. int y1 = p1.get(1);
  22. int x2 = p2.get(0);
  23. int y2 = p2.get(1);
  24. if (x1 != x2) {
  25. return x1 - x2;
  26. } else {
  27. return y1 - y2;
  28. }
  29. }
  30. });
  31. TreeMap<Integer, Integer> treeMap = new TreeMap<>(new Comparator<Integer>() {
  32. @Override
  33. public int compare(Integer i1, Integer i2) {
  34. return i2 - i1;
  35. }
  36. });
  37. treeMap.put(0, 1);
  38. int preMax = 0;
  39. for (List<Integer> p : points) {
  40. int x = p.get(0);
  41. int y = p.get(1);
  42. if (y < 0) {
  43. Integer v = treeMap.get(-y);
  44. if (v == null) {
  45. treeMap.put(-y, 1);
  46. } else {
  47. treeMap.put(-y, v + 1);
  48. }
  49. } else {
  50. Integer v = treeMap.get(y);
  51. if (v == 1) {
  52. treeMap.remove(y);
  53. } else {
  54. treeMap.put(y, v - 1);
  55. }
  56. }
  57. int curMax = treeMap.firstKey();
  58. if (curMax != preMax) {
  59. List<Integer> temp = new ArrayList<>();
  60. temp.add(x);
  61. temp.add(curMax);
  62. results.add(temp);
  63. preMax = curMax;
  64. }
  65. }
  66. return results;
  67. }

这道题确实很难想,虽然知道解法了,但还是想不到大神们是怎么想出来的,革命尚未成功,同志仍需努力,继续加油吧。

windliang wechat

添加好友一起进步~

如果觉得有帮助的话,可以点击 这里 给一个 star 哦 ^^

如果想系统的学习数据结构和算法,强烈推荐一个我之前学过的课程,可以点击 这里 查看详情